// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/ErrorWarning.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/detail/error_warning__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `ibeo_header`
#include "ibeo_msgs/msg/detail/ibeo_data_header__functions.h"

bool
ibeo_msgs__msg__ErrorWarning__init(ibeo_msgs__msg__ErrorWarning * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ibeo_msgs__msg__ErrorWarning__fini(msg);
    return false;
  }
  // ibeo_header
  if (!ibeo_msgs__msg__IbeoDataHeader__init(&msg->ibeo_header)) {
    ibeo_msgs__msg__ErrorWarning__fini(msg);
    return false;
  }
  // err_internal_error
  // err_motor_1_fault
  // err_buffer_error_xmt_incomplete
  // err_buffer_error_overflow
  // err_apd_over_temperature
  // err_apd_under_temperature
  // err_apd_temperature_sensor_defect
  // err_motor_2_fault
  // err_motor_3_fault
  // err_motor_4_fault
  // err_motor_5_fault
  // err_int_no_scan_data
  // err_int_communication_error
  // err_int_incorrect_scan_data
  // err_config_fpga_not_configurable
  // err_config_incorrect_config_data
  // err_config_contains_incorrect_params
  // err_timeout_data_processing
  // err_timeout_env_model_computation_reset
  // wrn_int_communication_error
  // wrn_low_temperature
  // wrn_high_temperature
  // wrn_int_motor_1
  // wrn_sync_error
  // wrn_laser_1_start_pulse_missing
  // wrn_laser_2_start_pulse_missing
  // wrn_can_interface_blocked
  // wrn_eth_interface_blocked
  // wrn_incorrect_can_data_rcvd
  // wrn_int_incorrect_scan_data
  // wrn_eth_unkwn_incomplete_data
  // wrn_incorrect_or_forbidden_cmd_rcvd
  // wrn_memory_access_failure
  // wrn_int_overflow
  // wrn_ego_motion_data_missing
  // wrn_incorrect_mounting_params
  // wrn_no_obj_comp_due_to_scan_freq
  return true;
}

void
ibeo_msgs__msg__ErrorWarning__fini(ibeo_msgs__msg__ErrorWarning * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ibeo_header
  ibeo_msgs__msg__IbeoDataHeader__fini(&msg->ibeo_header);
  // err_internal_error
  // err_motor_1_fault
  // err_buffer_error_xmt_incomplete
  // err_buffer_error_overflow
  // err_apd_over_temperature
  // err_apd_under_temperature
  // err_apd_temperature_sensor_defect
  // err_motor_2_fault
  // err_motor_3_fault
  // err_motor_4_fault
  // err_motor_5_fault
  // err_int_no_scan_data
  // err_int_communication_error
  // err_int_incorrect_scan_data
  // err_config_fpga_not_configurable
  // err_config_incorrect_config_data
  // err_config_contains_incorrect_params
  // err_timeout_data_processing
  // err_timeout_env_model_computation_reset
  // wrn_int_communication_error
  // wrn_low_temperature
  // wrn_high_temperature
  // wrn_int_motor_1
  // wrn_sync_error
  // wrn_laser_1_start_pulse_missing
  // wrn_laser_2_start_pulse_missing
  // wrn_can_interface_blocked
  // wrn_eth_interface_blocked
  // wrn_incorrect_can_data_rcvd
  // wrn_int_incorrect_scan_data
  // wrn_eth_unkwn_incomplete_data
  // wrn_incorrect_or_forbidden_cmd_rcvd
  // wrn_memory_access_failure
  // wrn_int_overflow
  // wrn_ego_motion_data_missing
  // wrn_incorrect_mounting_params
  // wrn_no_obj_comp_due_to_scan_freq
}

ibeo_msgs__msg__ErrorWarning *
ibeo_msgs__msg__ErrorWarning__create()
{
  ibeo_msgs__msg__ErrorWarning * msg = (ibeo_msgs__msg__ErrorWarning *)malloc(sizeof(ibeo_msgs__msg__ErrorWarning));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__ErrorWarning));
  bool success = ibeo_msgs__msg__ErrorWarning__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__ErrorWarning__destroy(ibeo_msgs__msg__ErrorWarning * msg)
{
  if (msg) {
    ibeo_msgs__msg__ErrorWarning__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__ErrorWarning__Sequence__init(ibeo_msgs__msg__ErrorWarning__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__ErrorWarning * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__ErrorWarning *)calloc(size, sizeof(ibeo_msgs__msg__ErrorWarning));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__ErrorWarning__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__ErrorWarning__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__ErrorWarning__Sequence__fini(ibeo_msgs__msg__ErrorWarning__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__ErrorWarning__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__ErrorWarning__Sequence *
ibeo_msgs__msg__ErrorWarning__Sequence__create(size_t size)
{
  ibeo_msgs__msg__ErrorWarning__Sequence * array = (ibeo_msgs__msg__ErrorWarning__Sequence *)malloc(sizeof(ibeo_msgs__msg__ErrorWarning__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__ErrorWarning__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__ErrorWarning__Sequence__destroy(ibeo_msgs__msg__ErrorWarning__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__ErrorWarning__Sequence__fini(array);
  }
  free(array);
}
