// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/Object2280.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/detail/object2280__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `object_box_center`
// Member `object_box_center_sigma`
// Member `object_box_size`
// Member `relative_velocity`
// Member `relative_velocity_sigma`
// Member `absolute_velocity`
// Member `absolute_velocity_sigma`
// Member `reference_point_coordinate`
// Member `reference_point_coordinate_sigma`
// Member `contour_point_list`
#include "ibeo_msgs/msg/detail/point2_df__functions.h"

bool
ibeo_msgs__msg__Object2280__init(ibeo_msgs__msg__Object2280 * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // tracking_model
  // mobility_of_dyn_object_detected
  // motion_model_validated
  // object_age
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // object_prediction_age
  // classification
  // classification_certainty
  // classification_age
  // object_box_center
  if (!ibeo_msgs__msg__Point2Df__init(&msg->object_box_center)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // object_box_center_sigma
  if (!ibeo_msgs__msg__Point2Df__init(&msg->object_box_center_sigma)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // object_box_size
  if (!ibeo_msgs__msg__Point2Df__init(&msg->object_box_size)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // object_box_orientation_angle
  // object_box_orientation_angle_sigma
  // relative_velocity
  if (!ibeo_msgs__msg__Point2Df__init(&msg->relative_velocity)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // relative_velocity_sigma
  if (!ibeo_msgs__msg__Point2Df__init(&msg->relative_velocity_sigma)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // absolute_velocity
  if (!ibeo_msgs__msg__Point2Df__init(&msg->absolute_velocity)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // absolute_velocity_sigma
  if (!ibeo_msgs__msg__Point2Df__init(&msg->absolute_velocity_sigma)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // number_of_contour_points
  // closest_point_index
  // reference_point_location
  // reference_point_coordinate
  if (!ibeo_msgs__msg__Point2Df__init(&msg->reference_point_coordinate)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // reference_point_coordinate_sigma
  if (!ibeo_msgs__msg__Point2Df__init(&msg->reference_point_coordinate_sigma)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  // reference_point_position_correction_coefficient
  // object_priority
  // object_existence_measurement
  // contour_point_list
  if (!ibeo_msgs__msg__Point2Df__Sequence__init(&msg->contour_point_list, 0)) {
    ibeo_msgs__msg__Object2280__fini(msg);
    return false;
  }
  return true;
}

void
ibeo_msgs__msg__Object2280__fini(ibeo_msgs__msg__Object2280 * msg)
{
  if (!msg) {
    return;
  }
  // id
  // tracking_model
  // mobility_of_dyn_object_detected
  // motion_model_validated
  // object_age
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // object_prediction_age
  // classification
  // classification_certainty
  // classification_age
  // object_box_center
  ibeo_msgs__msg__Point2Df__fini(&msg->object_box_center);
  // object_box_center_sigma
  ibeo_msgs__msg__Point2Df__fini(&msg->object_box_center_sigma);
  // object_box_size
  ibeo_msgs__msg__Point2Df__fini(&msg->object_box_size);
  // object_box_orientation_angle
  // object_box_orientation_angle_sigma
  // relative_velocity
  ibeo_msgs__msg__Point2Df__fini(&msg->relative_velocity);
  // relative_velocity_sigma
  ibeo_msgs__msg__Point2Df__fini(&msg->relative_velocity_sigma);
  // absolute_velocity
  ibeo_msgs__msg__Point2Df__fini(&msg->absolute_velocity);
  // absolute_velocity_sigma
  ibeo_msgs__msg__Point2Df__fini(&msg->absolute_velocity_sigma);
  // number_of_contour_points
  // closest_point_index
  // reference_point_location
  // reference_point_coordinate
  ibeo_msgs__msg__Point2Df__fini(&msg->reference_point_coordinate);
  // reference_point_coordinate_sigma
  ibeo_msgs__msg__Point2Df__fini(&msg->reference_point_coordinate_sigma);
  // reference_point_position_correction_coefficient
  // object_priority
  // object_existence_measurement
  // contour_point_list
  ibeo_msgs__msg__Point2Df__Sequence__fini(&msg->contour_point_list);
}

ibeo_msgs__msg__Object2280 *
ibeo_msgs__msg__Object2280__create()
{
  ibeo_msgs__msg__Object2280 * msg = (ibeo_msgs__msg__Object2280 *)malloc(sizeof(ibeo_msgs__msg__Object2280));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__Object2280));
  bool success = ibeo_msgs__msg__Object2280__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__Object2280__destroy(ibeo_msgs__msg__Object2280 * msg)
{
  if (msg) {
    ibeo_msgs__msg__Object2280__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__Object2280__Sequence__init(ibeo_msgs__msg__Object2280__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__Object2280 * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__Object2280 *)calloc(size, sizeof(ibeo_msgs__msg__Object2280));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__Object2280__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__Object2280__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__Object2280__Sequence__fini(ibeo_msgs__msg__Object2280__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__Object2280__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__Object2280__Sequence *
ibeo_msgs__msg__Object2280__Sequence__create(size_t size)
{
  ibeo_msgs__msg__Object2280__Sequence * array = (ibeo_msgs__msg__Object2280__Sequence *)malloc(sizeof(ibeo_msgs__msg__Object2280__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__Object2280__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__Object2280__Sequence__destroy(ibeo_msgs__msg__Object2280__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__Object2280__Sequence__fini(array);
  }
  free(array);
}
