// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/ScannerInfo2205.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/detail/scanner_info2205__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `scan_start_time`
// Member `scan_end_time`
// Member `scan_start_time_from_device`
// Member `scan_end_time_from_device`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `mounting_position`
#include "ibeo_msgs/msg/detail/mounting_position_f__functions.h"
// Member `resolutions`
#include "ibeo_msgs/msg/detail/resolution_info__functions.h"

bool
ibeo_msgs__msg__ScannerInfo2205__init(ibeo_msgs__msg__ScannerInfo2205 * msg)
{
  if (!msg) {
    return false;
  }
  // device_id
  // scanner_type
  // scan_number
  // start_angle
  // end_angle
  // scan_start_time
  if (!builtin_interfaces__msg__Time__init(&msg->scan_start_time)) {
    ibeo_msgs__msg__ScannerInfo2205__fini(msg);
    return false;
  }
  // scan_end_time
  if (!builtin_interfaces__msg__Time__init(&msg->scan_end_time)) {
    ibeo_msgs__msg__ScannerInfo2205__fini(msg);
    return false;
  }
  // scan_start_time_from_device
  if (!builtin_interfaces__msg__Time__init(&msg->scan_start_time_from_device)) {
    ibeo_msgs__msg__ScannerInfo2205__fini(msg);
    return false;
  }
  // scan_end_time_from_device
  if (!builtin_interfaces__msg__Time__init(&msg->scan_end_time_from_device)) {
    ibeo_msgs__msg__ScannerInfo2205__fini(msg);
    return false;
  }
  // scan_frequency
  // beam_tilt
  // scan_flags
  // mounting_position
  if (!ibeo_msgs__msg__MountingPositionF__init(&msg->mounting_position)) {
    ibeo_msgs__msg__ScannerInfo2205__fini(msg);
    return false;
  }
  // resolutions
  for (size_t i = 0; i < 8; ++i) {
    if (!ibeo_msgs__msg__ResolutionInfo__init(&msg->resolutions[i])) {
      ibeo_msgs__msg__ScannerInfo2205__fini(msg);
      return false;
    }
  }
  return true;
}

void
ibeo_msgs__msg__ScannerInfo2205__fini(ibeo_msgs__msg__ScannerInfo2205 * msg)
{
  if (!msg) {
    return;
  }
  // device_id
  // scanner_type
  // scan_number
  // start_angle
  // end_angle
  // scan_start_time
  builtin_interfaces__msg__Time__fini(&msg->scan_start_time);
  // scan_end_time
  builtin_interfaces__msg__Time__fini(&msg->scan_end_time);
  // scan_start_time_from_device
  builtin_interfaces__msg__Time__fini(&msg->scan_start_time_from_device);
  // scan_end_time_from_device
  builtin_interfaces__msg__Time__fini(&msg->scan_end_time_from_device);
  // scan_frequency
  // beam_tilt
  // scan_flags
  // mounting_position
  ibeo_msgs__msg__MountingPositionF__fini(&msg->mounting_position);
  // resolutions
  for (size_t i = 0; i < 8; ++i) {
    ibeo_msgs__msg__ResolutionInfo__fini(&msg->resolutions[i]);
  }
}

ibeo_msgs__msg__ScannerInfo2205 *
ibeo_msgs__msg__ScannerInfo2205__create()
{
  ibeo_msgs__msg__ScannerInfo2205 * msg = (ibeo_msgs__msg__ScannerInfo2205 *)malloc(sizeof(ibeo_msgs__msg__ScannerInfo2205));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__ScannerInfo2205));
  bool success = ibeo_msgs__msg__ScannerInfo2205__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__ScannerInfo2205__destroy(ibeo_msgs__msg__ScannerInfo2205 * msg)
{
  if (msg) {
    ibeo_msgs__msg__ScannerInfo2205__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__ScannerInfo2205__Sequence__init(ibeo_msgs__msg__ScannerInfo2205__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__ScannerInfo2205 * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__ScannerInfo2205 *)calloc(size, sizeof(ibeo_msgs__msg__ScannerInfo2205));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__ScannerInfo2205__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__ScannerInfo2205__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__ScannerInfo2205__Sequence__fini(ibeo_msgs__msg__ScannerInfo2205__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__ScannerInfo2205__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__ScannerInfo2205__Sequence *
ibeo_msgs__msg__ScannerInfo2205__Sequence__create(size_t size)
{
  ibeo_msgs__msg__ScannerInfo2205__Sequence * array = (ibeo_msgs__msg__ScannerInfo2205__Sequence *)malloc(sizeof(ibeo_msgs__msg__ScannerInfo2205__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__ScannerInfo2205__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__ScannerInfo2205__Sequence__destroy(ibeo_msgs__msg__ScannerInfo2205__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__ScannerInfo2205__Sequence__fini(array);
  }
  free(array);
}
