// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/CameraImage.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/detail/camera_image__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `ibeo_header`
#include "ibeo_msgs/msg/detail/ibeo_data_header__functions.h"
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `mounting_position`
#include "ibeo_msgs/msg/detail/mounting_position_f__functions.h"
// Member `image_buffer`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
ibeo_msgs__msg__CameraImage__init(ibeo_msgs__msg__CameraImage * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ibeo_msgs__msg__CameraImage__fini(msg);
    return false;
  }
  // ibeo_header
  if (!ibeo_msgs__msg__IbeoDataHeader__init(&msg->ibeo_header)) {
    ibeo_msgs__msg__CameraImage__fini(msg);
    return false;
  }
  // image_format
  // us_since_power_on
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    ibeo_msgs__msg__CameraImage__fini(msg);
    return false;
  }
  // device_id
  // mounting_position
  if (!ibeo_msgs__msg__MountingPositionF__init(&msg->mounting_position)) {
    ibeo_msgs__msg__CameraImage__fini(msg);
    return false;
  }
  // horizontal_opening_angle
  // vertical_opening_angle
  // image_width
  // image_height
  // compressed_size
  // image_buffer
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->image_buffer, 0)) {
    ibeo_msgs__msg__CameraImage__fini(msg);
    return false;
  }
  return true;
}

void
ibeo_msgs__msg__CameraImage__fini(ibeo_msgs__msg__CameraImage * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ibeo_header
  ibeo_msgs__msg__IbeoDataHeader__fini(&msg->ibeo_header);
  // image_format
  // us_since_power_on
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // device_id
  // mounting_position
  ibeo_msgs__msg__MountingPositionF__fini(&msg->mounting_position);
  // horizontal_opening_angle
  // vertical_opening_angle
  // image_width
  // image_height
  // compressed_size
  // image_buffer
  rosidl_runtime_c__uint8__Sequence__fini(&msg->image_buffer);
}

ibeo_msgs__msg__CameraImage *
ibeo_msgs__msg__CameraImage__create()
{
  ibeo_msgs__msg__CameraImage * msg = (ibeo_msgs__msg__CameraImage *)malloc(sizeof(ibeo_msgs__msg__CameraImage));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__CameraImage));
  bool success = ibeo_msgs__msg__CameraImage__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__CameraImage__destroy(ibeo_msgs__msg__CameraImage * msg)
{
  if (msg) {
    ibeo_msgs__msg__CameraImage__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__CameraImage__Sequence__init(ibeo_msgs__msg__CameraImage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__CameraImage * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__CameraImage *)calloc(size, sizeof(ibeo_msgs__msg__CameraImage));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__CameraImage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__CameraImage__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__CameraImage__Sequence__fini(ibeo_msgs__msg__CameraImage__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__CameraImage__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__CameraImage__Sequence *
ibeo_msgs__msg__CameraImage__Sequence__create(size_t size)
{
  ibeo_msgs__msg__CameraImage__Sequence * array = (ibeo_msgs__msg__CameraImage__Sequence *)malloc(sizeof(ibeo_msgs__msg__CameraImage__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__CameraImage__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__CameraImage__Sequence__destroy(ibeo_msgs__msg__CameraImage__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__CameraImage__Sequence__fini(array);
  }
  free(array);
}
