// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/ScanData2205.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/detail/scan_data2205__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `ibeo_header`
#include "ibeo_msgs/msg/detail/ibeo_data_header__functions.h"
// Member `scan_start_time`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `scanner_info_list`
#include "ibeo_msgs/msg/detail/scanner_info2205__functions.h"
// Member `scan_point_list`
#include "ibeo_msgs/msg/detail/scan_point2205__functions.h"

bool
ibeo_msgs__msg__ScanData2205__init(ibeo_msgs__msg__ScanData2205 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ibeo_msgs__msg__ScanData2205__fini(msg);
    return false;
  }
  // ibeo_header
  if (!ibeo_msgs__msg__IbeoDataHeader__init(&msg->ibeo_header)) {
    ibeo_msgs__msg__ScanData2205__fini(msg);
    return false;
  }
  // scan_start_time
  if (!builtin_interfaces__msg__Time__init(&msg->scan_start_time)) {
    ibeo_msgs__msg__ScanData2205__fini(msg);
    return false;
  }
  // scan_end_time_offset
  // fused_scan
  // mirror_side
  // coordinate_system
  // scan_number
  // scan_points
  // number_of_scanner_infos
  // scanner_info_list
  if (!ibeo_msgs__msg__ScannerInfo2205__Sequence__init(&msg->scanner_info_list, 0)) {
    ibeo_msgs__msg__ScanData2205__fini(msg);
    return false;
  }
  // scan_point_list
  if (!ibeo_msgs__msg__ScanPoint2205__Sequence__init(&msg->scan_point_list, 0)) {
    ibeo_msgs__msg__ScanData2205__fini(msg);
    return false;
  }
  return true;
}

void
ibeo_msgs__msg__ScanData2205__fini(ibeo_msgs__msg__ScanData2205 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ibeo_header
  ibeo_msgs__msg__IbeoDataHeader__fini(&msg->ibeo_header);
  // scan_start_time
  builtin_interfaces__msg__Time__fini(&msg->scan_start_time);
  // scan_end_time_offset
  // fused_scan
  // mirror_side
  // coordinate_system
  // scan_number
  // scan_points
  // number_of_scanner_infos
  // scanner_info_list
  ibeo_msgs__msg__ScannerInfo2205__Sequence__fini(&msg->scanner_info_list);
  // scan_point_list
  ibeo_msgs__msg__ScanPoint2205__Sequence__fini(&msg->scan_point_list);
}

ibeo_msgs__msg__ScanData2205 *
ibeo_msgs__msg__ScanData2205__create()
{
  ibeo_msgs__msg__ScanData2205 * msg = (ibeo_msgs__msg__ScanData2205 *)malloc(sizeof(ibeo_msgs__msg__ScanData2205));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__ScanData2205));
  bool success = ibeo_msgs__msg__ScanData2205__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__ScanData2205__destroy(ibeo_msgs__msg__ScanData2205 * msg)
{
  if (msg) {
    ibeo_msgs__msg__ScanData2205__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__ScanData2205__Sequence__init(ibeo_msgs__msg__ScanData2205__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__ScanData2205 * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__ScanData2205 *)calloc(size, sizeof(ibeo_msgs__msg__ScanData2205));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__ScanData2205__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__ScanData2205__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__ScanData2205__Sequence__fini(ibeo_msgs__msg__ScanData2205__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__ScanData2205__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__ScanData2205__Sequence *
ibeo_msgs__msg__ScanData2205__Sequence__create(size_t size)
{
  ibeo_msgs__msg__ScanData2205__Sequence * array = (ibeo_msgs__msg__ScanData2205__Sequence *)malloc(sizeof(ibeo_msgs__msg__ScanData2205__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__ScanData2205__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__ScanData2205__Sequence__destroy(ibeo_msgs__msg__ScanData2205__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__ScanData2205__Sequence__fini(array);
  }
  free(array);
}
