// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ibeo_msgs:msg/UntrackedProperties.idl
// generated code does not contain a copyright notice
#include "ibeo_msgs/msg/detail/untracked_properties__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `position_closest_point`
// Member `object_box_size`
// Member `tracking_point_coordinate`
#include "ibeo_msgs/msg/detail/point2_di__functions.h"
// Member `object_box_size_sigma`
// Member `tracking_point_coordinate_sigma`
#include "ibeo_msgs/msg/detail/point2_dui__functions.h"
// Member `contour_point_list`
#include "ibeo_msgs/msg/detail/contour_point_sigma__functions.h"

bool
ibeo_msgs__msg__UntrackedProperties__init(ibeo_msgs__msg__UntrackedProperties * msg)
{
  if (!msg) {
    return false;
  }
  // relative_time_of_measurement
  // position_closest_point
  if (!ibeo_msgs__msg__Point2Di__init(&msg->position_closest_point)) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
    return false;
  }
  // object_box_size
  if (!ibeo_msgs__msg__Point2Di__init(&msg->object_box_size)) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
    return false;
  }
  // object_box_size_sigma
  if (!ibeo_msgs__msg__Point2Dui__init(&msg->object_box_size_sigma)) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
    return false;
  }
  // object_box_orientation
  // object_box_orientation_sigma
  // tracking_point_coordinate
  if (!ibeo_msgs__msg__Point2Di__init(&msg->tracking_point_coordinate)) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
    return false;
  }
  // tracking_point_coordinate_sigma
  if (!ibeo_msgs__msg__Point2Dui__init(&msg->tracking_point_coordinate_sigma)) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
    return false;
  }
  // number_of_contour_points
  // contour_point_list
  if (!ibeo_msgs__msg__ContourPointSigma__Sequence__init(&msg->contour_point_list, 0)) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
    return false;
  }
  return true;
}

void
ibeo_msgs__msg__UntrackedProperties__fini(ibeo_msgs__msg__UntrackedProperties * msg)
{
  if (!msg) {
    return;
  }
  // relative_time_of_measurement
  // position_closest_point
  ibeo_msgs__msg__Point2Di__fini(&msg->position_closest_point);
  // object_box_size
  ibeo_msgs__msg__Point2Di__fini(&msg->object_box_size);
  // object_box_size_sigma
  ibeo_msgs__msg__Point2Dui__fini(&msg->object_box_size_sigma);
  // object_box_orientation
  // object_box_orientation_sigma
  // tracking_point_coordinate
  ibeo_msgs__msg__Point2Di__fini(&msg->tracking_point_coordinate);
  // tracking_point_coordinate_sigma
  ibeo_msgs__msg__Point2Dui__fini(&msg->tracking_point_coordinate_sigma);
  // number_of_contour_points
  // contour_point_list
  ibeo_msgs__msg__ContourPointSigma__Sequence__fini(&msg->contour_point_list);
}

ibeo_msgs__msg__UntrackedProperties *
ibeo_msgs__msg__UntrackedProperties__create()
{
  ibeo_msgs__msg__UntrackedProperties * msg = (ibeo_msgs__msg__UntrackedProperties *)malloc(sizeof(ibeo_msgs__msg__UntrackedProperties));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ibeo_msgs__msg__UntrackedProperties));
  bool success = ibeo_msgs__msg__UntrackedProperties__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ibeo_msgs__msg__UntrackedProperties__destroy(ibeo_msgs__msg__UntrackedProperties * msg)
{
  if (msg) {
    ibeo_msgs__msg__UntrackedProperties__fini(msg);
  }
  free(msg);
}


bool
ibeo_msgs__msg__UntrackedProperties__Sequence__init(ibeo_msgs__msg__UntrackedProperties__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ibeo_msgs__msg__UntrackedProperties * data = NULL;
  if (size) {
    data = (ibeo_msgs__msg__UntrackedProperties *)calloc(size, sizeof(ibeo_msgs__msg__UntrackedProperties));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ibeo_msgs__msg__UntrackedProperties__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ibeo_msgs__msg__UntrackedProperties__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ibeo_msgs__msg__UntrackedProperties__Sequence__fini(ibeo_msgs__msg__UntrackedProperties__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ibeo_msgs__msg__UntrackedProperties__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ibeo_msgs__msg__UntrackedProperties__Sequence *
ibeo_msgs__msg__UntrackedProperties__Sequence__create(size_t size)
{
  ibeo_msgs__msg__UntrackedProperties__Sequence * array = (ibeo_msgs__msg__UntrackedProperties__Sequence *)malloc(sizeof(ibeo_msgs__msg__UntrackedProperties__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ibeo_msgs__msg__UntrackedProperties__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ibeo_msgs__msg__UntrackedProperties__Sequence__destroy(ibeo_msgs__msg__UntrackedProperties__Sequence * array)
{
  if (array) {
    ibeo_msgs__msg__UntrackedProperties__Sequence__fini(array);
  }
  free(array);
}
